Skip to main content

## Type

# Enum Type

Source

    pub enum Type {
    Show 14 variants    ResolvedPath(Path),
        DynTrait(DynTrait),
        Generic(String),
        Primitive(String),
        FunctionPointer(Box<FunctionPointer>),
        Tuple(Vec<Type>),
        Slice(Box<Type>),
        Array {
            type_: Box<Type>,
            len: String,
        },
        Pat {
            type_: Box<Type>,
            /* private fields */
        },
        ImplTrait(Vec<GenericBound>),
        Infer,
        RawPointer {
            is_mutable: bool,
            type_: Box<Type>,
        },
        BorrowedRef {
            lifetime: Option<String>,
            is_mutable: bool,
            type_: Box<Type>,
        },
        QualifiedPath {
            name: String,
            args: Option<Box<GenericArgs>>,
            self_type: Box<Type>,
            trait_: Option<Path>,
        },
    }

Expand description

A type.

## Variants§

§

### ResolvedPath(Path)

Structs, enums, unions and type aliases, e.g. `std::option::Option<u32>`

§

### DynTrait(DynTrait)

Dynamic trait object type (`dyn Trait`).

§

### Generic(String)

Parameterized types. The contained string is the name of the parameter.

§

### Primitive(String)

Built-in numeric types (e.g. `u32`, `f32`), `bool`, `char`.

§

### FunctionPointer(Box<FunctionPointer>)

A function pointer type, e.g. `fn(u32) -> u32`, `extern "C" fn() -> *const u8`

§

### Tuple(Vec<Type>)

A tuple type, e.g. `(String, u32, Box<usize>)`

§

### Slice(Box<Type>)

An unsized slice type, e.g. `[u32]`.

§

### Array

An array type, e.g. `[u32; 15]`

#### Fields

§`type_: Box<Type>`

The type of the contained element.

§`len: String`

The stringified expression that is the length of the array.

Keep in mind that it’s not guaranteed to match the actual source code of the expression.

§

### Pat

A pattern type, e.g. `u32 is 1..`

See the tracking issue

#### Fields

§`type_: Box<Type>`

The base type, e.g. the `u32` in `u32 is 1..`

§

### ImplTrait(Vec<GenericBound>)

An opaque type that satisfies a set of bounds, `impl TraitA + TraitB + ...`

§

### Infer

A type that’s left to be inferred, `_`

§

### RawPointer

A raw pointer type, e.g. `*mut u32`, `*const u8`, etc.

#### Fields

§`is_mutable: bool`

This is `true` for `*mut _` and `false` for `*const _`.

§`type_: Box<Type>`

The type of the pointee.

§

### BorrowedRef

`&'a mut String`, `&str`, etc.

#### Fields

§`lifetime: Option<String>`

The name of the lifetime of the reference, if provided.

§`is_mutable: bool`

This is `true` for `&mut i32` and `false` for `&i32`

§`type_: Box<Type>`

The type of the pointee, e.g. the `i32` in `&'a mut i32`

§

### QualifiedPath

Associated types like `<Type as Trait>::Name` and `T::Item` where `T: Iterator` or inherent associated types like `Struct::Name`.

#### Fields

§`name: String`

The name of the associated type in the parent type.

ⓘ

    <core::array::IntoIter<u32, 42> as Iterator>::Item
    //                                            ^^^^

§`args: Option<Box<GenericArgs>>`

The generic arguments provided to the associated type.

ⓘ

    <core::slice::IterMut<'static, u32> as BetterIterator>::Item<'static>
    //                                                          ^^^^^^^^^

§`self_type: Box<Type>`

The type with which this type is associated.

ⓘ

    <core::array::IntoIter<u32, 42> as Iterator>::Item
    // ^^^^^^^^^^^^^^^^^^^^^^^^^^^^

§`trait_: Option<Path>`

`None` iff this is an inherent associated type.

## Trait Implementations§

Source§

### impl Clone for Type

Source§

#### fn clone(&self) -> Type

Returns a duplicate of the value. Read more
1.0.0 (const: unstable) · Source§

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more
Source§

### impl Debug for Type

Source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more
Source§

### impl<'de> Deserialize<'de> for Type

Source§

#### fn deserialize<__D>(__deserializer: __D) -> Result<Self, __D::Error>
where __D: Deserializer<'de>,

Deserialize this value from the given Serde deserializer. Read more
Source§

### impl Eq for Type

Source§

### impl Hash for Type

Source§

#### fn hash<__H: Hasher>(&self, state: &mut __H)

Feeds this value into the given `Hasher`. Read more
1.3.0 · Source§

#### fn hash_slice<H>(data: &[Self], state: &mut H)
where H: Hasher, Self: Sized,

Feeds a slice of this type into the given `Hasher`. Read more
Source§

### impl PartialEq for Type

Source§

#### fn eq(&self, other: &Type) -> bool

Tests for `self` and `other` values to be equal, and is used by `==`.
1.0.0 (const: unstable) · Source§

#### fn ne(&self, other: &Rhs) -> bool

Tests for `!=`. The default implementation is almost always sufficient, and should not be overridden without very good reason.
Source§

### impl Serialize for Type

Source§

#### fn serialize<__S>(&self, __serializer: __S) -> Result<__S::Ok, __S::Error>
where __S: Serializer,

Serialize this value into the given Serde serializer. Read more
Source§

### impl StructuralPartialEq for Type

## Auto Trait Implementations§

§

### impl Freeze for Type

§

### impl RefUnwindSafe for Type

§

### impl Send for Type

§

### impl Sync for Type

§

### impl Unpin for Type

§

### impl UnsafeUnpin for Type

§

### impl UnwindSafe for Type

## Blanket Implementations§

Source§

### impl<T> Any for T
where T: 'static + ?Sized,

Source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
Source§

### impl<T> Borrow<T> for T
where T: ?Sized,

Source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
Source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

Source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
Source§

### impl<T> CloneToUninit for T
where T: Clone,

Source§

#### unsafe fn clone_to_uninit(&self, dest: *mut u8)

🔬This is a nightly-only experimental API. (`clone_to_uninit`)
Performs copy-assignment from `self` to `dest`. Read more
Source§

### impl<T> DeserializeOwned for T
where T: for<'de> Deserialize<'de>,

Source§

### impl<T> From<T> for T

Source§

#### fn from(t: T) -> T

Returns the argument unchanged.

Source§

### impl<T, U> Into<U> for T
where U: From<T>,

Source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

Source§

### impl<T> ToOwned for T
where T: Clone,

Source§

#### type Owned = T

The resulting type after obtaining ownership.
Source§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
Source§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
Source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

Source§

#### type Error = Infallible

The type returned in the event of a conversion error.
Source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
Source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

Source§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
Source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 80 bytes

Size for each variant:

- `ResolvedPath`: 48 bytes
- `DynTrait`: 56 bytes
- `Generic`: 32 bytes
- `Primitive`: 32 bytes
- `FunctionPointer`: 16 bytes
- `Tuple`: 32 bytes
- `Slice`: 16 bytes
- `Array`: 40 bytes
- `Pat`: 40 bytes
- `ImplTrait`: 32 bytes
- `Infer`: 0 bytes
- `RawPointer`: 24 bytes
- `BorrowedRef`: 48 bytes
- `QualifiedPath`: 80 bytes